/*
 * Decompiled with CFR 0.152.
 */
package com.jiuqi.mde;

import com.jiuqi.mde.MDEDimension;
import com.jiuqi.mde.MDEDimensionSet;
import com.jiuqi.mde.MDEException;
import java.io.UnsupportedEncodingException;
import java.net.URLDecoder;
import java.net.URLEncoder;
import java.util.Arrays;
import java.util.StringTokenizer;

public final class MDEDimValueSet
implements Cloneable,
Comparable {
    private MDEDimensionSet dimensions;
    private Object[] dimValues;

    public MDEDimValueSet(MDEDimensionSet dimensions) {
        this.dimensions = dimensions;
        this.dimValues = new Object[dimensions.size()];
    }

    public int size() {
        return this.dimensions.size();
    }

    public MDEDimensionSet dimensions() {
        return this.dimensions;
    }

    public MDEDimension getDimension(int index) {
        return this.dimensions.get(index);
    }

    public Object getValue(int index) {
        return this.dimValues[index];
    }

    public Object getValue(MDEDimension dimension) {
        int index = this.dimensions.indexOf(dimension);
        return index >= 0 ? this.dimValues[index] : null;
    }

    public Object getValue(String dimName) {
        int index = this.dimensions.indexOf(dimName);
        return index >= 0 ? this.dimValues[index] : null;
    }

    public void setValue(int index, Object value) {
        this.dimValues[index] = value == null ? null : (this.dimensions.get((int)index).isString ? value.toString() : (value instanceof Double ? new Integer(((Double)value).intValue()) : value));
    }

    public void setValue(MDEDimension dimension, Object value) {
        int index = this.dimensions.indexOf(dimension);
        if (index >= 0) {
            this.setValue(index, value);
        }
    }

    public void setValue(String dimName, Object value) {
        int index = this.dimensions.indexOf(dimName);
        if (index >= 0) {
            this.setValue(index, value);
        }
    }

    public Object[] getDimValues() {
        return this.dimValues;
    }

    public void setDimValues(Object[] dimValues) {
        this.dimValues = dimValues;
    }

    public void assignValues(MDEDimValueSet source) {
        if (source == null) {
            return;
        }
        if (this.dimensions == source.dimensions) {
            int i = 0;
            int count = source.size();
            while (i < count) {
                this.dimValues[i] = source.dimValues[i];
                ++i;
            }
        } else {
            int i = 0;
            int count = source.size();
            while (i < count) {
                this.setValue(source.dimensions.get(i), source.dimValues[i]);
                ++i;
            }
        }
    }

    public void assignValues(MDEDimValueSet source, boolean assignNull) {
        if (source == null) {
            return;
        }
        if (this.dimensions == source.dimensions) {
            int i = 0;
            int count = source.size();
            while (i < count) {
                Object value = source.dimValues[i];
                if (assignNull || value != null) {
                    this.setValue(i, value);
                }
                ++i;
            }
        } else {
            int i = 0;
            int count = source.size();
            while (i < count) {
                Object value = source.dimValues[i];
                if (assignNull || value != null) {
                    this.setValue(source.dimensions.get(i), value);
                }
                ++i;
            }
        }
    }

    public void assignNullValues(MDEDimValueSet source) {
        if (source == null) {
            return;
        }
        int i = 0;
        int count = this.dimensions.size();
        while (i < count) {
            Object value = this.dimValues[i];
            if (value == null) {
                this.setValue(i, source.getValue(this.dimensions.get(i)));
            }
            ++i;
        }
    }

    public void clear() {
        Arrays.fill(this.dimValues, null);
    }

    public Object clone() {
        MDEDimValueSet result = new MDEDimValueSet(this.dimensions);
        int i = 0;
        int count = this.dimensions.size();
        while (i < count) {
            result.setValue(i, this.dimValues[i]);
            ++i;
        }
        return result;
    }

    public int compareTo(Object o) {
        if (this == o) {
            return 0;
        }
        if (o == null) {
            return 1;
        }
        if (this == null) {
            return -1;
        }
        if (o instanceof MDEDimValueSet) {
            int result = this.dimensions.compareTo(((MDEDimValueSet)o).dimensions);
            if (result != 0) {
                return result;
            }
            int i = 0;
            int count = this.dimensions.size();
            while (i < count) {
                Object o1 = this.dimValues[i];
                Object o2 = ((MDEDimValueSet)o).dimValues[i];
                if (o1 != o2) {
                    if (o1 == null) {
                        return -1;
                    }
                    if (o2 == null) {
                        return 1;
                    }
                    result = o1 instanceof Comparable ? ((Comparable)o1).compareTo(o2) : o1.hashCode() - o2.hashCode();
                    if (result != 0) {
                        return result;
                    }
                }
                ++i;
            }
            return result;
        }
        return this.hashCode() - o.hashCode();
    }

    public int compareNoOrder(Object o) {
        if (this == o) {
            return 0;
        }
        if (!(o instanceof MDEDimValueSet)) {
            return -1;
        }
        int result = this.dimensions.compareTo(((MDEDimValueSet)o).dimensions);
        if (result != 0) {
            return result;
        }
        int i = 0;
        int count = this.dimensions.size();
        while (i < count) {
            Object o2;
            Object o1;
            if (!this.dimensions.get((int)i).name.equals("顺序号") && (o1 = this.dimValues[i]) != (o2 = ((MDEDimValueSet)o).dimValues[i])) {
                if (o1 == null) {
                    return -1;
                }
                if (o2 == null) {
                    return 1;
                }
                result = o1 instanceof Comparable ? ((Comparable)o1).compareTo(o2) : o1.hashCode() - o2.hashCode();
                if (result != 0) {
                    return result;
                }
            }
            ++i;
        }
        return result;
    }

    public boolean equals(Object o) {
        if (!(o instanceof MDEDimValueSet)) {
            return false;
        }
        if (this.dimensions.compareTo(((MDEDimValueSet)o).dimensions) != 0) {
            return false;
        }
        int i = 0;
        int count = this.dimensions.size();
        while (i < count) {
            Object o1 = this.dimValues[i];
            Object o2 = ((MDEDimValueSet)o).dimValues[i];
            if (o1 != o2) {
                if (o1 == null || o2 == null) {
                    return false;
                }
                if (!o1.equals(o2)) {
                    return false;
                }
            }
            ++i;
        }
        return true;
    }

    public boolean matches(MDEDimValueSet speciafication) {
        if (speciafication == null) {
            return true;
        }
        int i = 0;
        int count = speciafication.dimensions.size();
        while (i < count) {
            Object value;
            MDEDimension dimension;
            int index;
            Object spec = speciafication.getValue(i);
            if (spec != null && (index = this.dimensions.indexOf(dimension = speciafication.dimensions.get(i))) >= 0 && !spec.equals(value = this.getValue(index))) {
                return false;
            }
            ++i;
        }
        return true;
    }

    protected boolean isNullValue(Object value) {
        return value == null || "".equals(value);
    }

    public boolean isEmpty() {
        int i = 0;
        while (i < this.dimValues.length) {
            if (!this.isNullValue(this.dimValues[i])) {
                return false;
            }
            ++i;
        }
        return true;
    }

    public boolean hasNullValue() {
        return this.hasNullValue(false);
    }

    public boolean hasNullValue(boolean includeOrder) {
        int i = 0;
        while (i < this.dimValues.length) {
            if (this.isNullValue(this.dimValues[i]) && (includeOrder || !"顺序号".equals(this.dimensions.get((int)i).name))) {
                return true;
            }
            ++i;
        }
        return false;
    }

    public String encodeData() {
        String result = "";
        int i = 0;
        while (i < this.dimensions.size()) {
            Object value = this.dimValues[i];
            String data = "";
            if (value != null) {
                if (this.dimensions.get((int)i).isString) {
                    data = (String)value;
                } else {
                    int numVal = value instanceof Integer ? ((Integer)value).intValue() : ((Double)value).intValue();
                    data = Integer.toString(numVal);
                }
            }
            if (i > 0) {
                result = String.valueOf(result) + "&";
            }
            try {
                result = String.valueOf(result) + URLEncoder.encode(data, "GBK");
            }
            catch (UnsupportedEncodingException e) {
                throw new RuntimeException("系统没有配置GBK字符集！", e);
            }
            ++i;
        }
        return result;
    }

    public void decodeData(String encodedData) throws MDEException {
        if (encodedData == null) {
            return;
        }
        try {
            int index = 0;
            StringTokenizer st = new StringTokenizer(encodedData, "&");
            while (st.hasMoreTokens()) {
                String data = st.nextToken();
                try {
                    data = URLDecoder.decode(data, "GBK");
                }
                catch (UnsupportedEncodingException e) {
                    throw new RuntimeException("系统没有配置GBK字符集！", e);
                }
                this.dimValues[index] = this.dimensions.get((int)index).isString ? data : Integer.valueOf(data);
                ++index;
            }
        }
        catch (NumberFormatException ex) {
            throw new MDEException(ex);
        }
    }

    public void parseString(String strData) throws MDEException {
        try {
            StringTokenizer st = new StringTokenizer(strData, ";,");
            while (st.hasMoreTokens()) {
                MDEDimension dim;
                String data = st.nextToken();
                int p = data.indexOf(61);
                if (p <= 0 || (dim = this.dimensions.find(data.substring(0, p).trim())) == null) continue;
                int index = this.dimensions.indexOf(dim);
                data = data.substring(p + 1);
                if (dim.isString) {
                    if (data.length() > 2 && data.charAt(0) == '\"' && data.charAt(data.length() - 1) == '\"') {
                        data = data.substring(1, data.length() - 2);
                    }
                    this.dimValues[index] = data;
                } else {
                    this.dimValues[index] = Integer.valueOf(data);
                }
                ++index;
            }
        }
        catch (NumberFormatException ex) {
            throw new MDEException(ex);
        }
    }

    public String toString() {
        StringBuffer result = new StringBuffer(64);
        boolean needComma = false;
        int i = 0;
        int count = this.dimensions.size();
        while (i < count) {
            if (this.dimValues[i] != null) {
                MDEDimension dimension = this.dimensions.get(i);
                if (needComma) {
                    result.append(", ");
                }
                result.append(dimension.name);
                result.append('=');
                if (dimension.isString) {
                    result.append('\"');
                    result.append((String)this.dimValues[i]);
                    result.append('\"');
                } else if (this.dimValues[i] instanceof Integer) {
                    result.append((Integer)this.dimValues[i]);
                } else {
                    result.append(this.dimValues[i].toString());
                }
                needComma = true;
            }
            ++i;
        }
        return result.toString();
    }

    public String getSQLFilter() {
        return this.getSQLFilter(false);
    }

    public String getSQLFilter(boolean isPrepared) {
        return this.getSQLFilter(null, isPrepared);
    }

    public String getSQLFilter(String tablePrefix) {
        return this.getSQLFilter(tablePrefix, false);
    }

    public String getSQLFilter(String tablePrefix, boolean isPrepared) {
        StringBuffer filter = new StringBuffer(128);
        boolean needAND = false;
        int i = 0;
        int count = this.dimensions.size();
        while (i < count) {
            if (this.dimValues[i] != null) {
                MDEDimension dimension = this.dimensions.get(i);
                if (needAND) {
                    filter.append(" AND ");
                }
                filter.append(dimension.getSQLFilter(tablePrefix, this.dimValues[i], isPrepared));
                needAND = true;
            }
            ++i;
        }
        return filter.toString();
    }
}

